Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision f7c0c4875e5eed9b9b820e4cd989c0203179be0b)
+++ src/molecule_dynamics.cpp	(revision 456e78e35fb62976d5ccc14000867cdfdf3da8bc)
@@ -484,5 +484,4 @@
            atoms.end(),
            boost::bind(&atom::EvaluateConstrainedForce,_1,startstep,endstep,PermutationMap,Force));
-  //ActOnAllAtoms( &atom::EvaluateConstrainedForce, startstep, endstep, PermutationMap, Force );
   DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 };
@@ -617,5 +616,4 @@
     // and perform Verlet integration for each atom with position, velocity and force vector
     // check size of vectors
-    //ActOnAllAtoms( &atom::ResizeTrajectory, MDSteps+10 );
     for_each(atoms.begin(),
              atoms.end(),
Index: c/test/ActOnAlltest.hpp
===================================================================
--- src/test/ActOnAlltest.hpp	(revision f7c0c4875e5eed9b9b820e4cd989c0203179be0b)
+++ 	(revision )
@@ -1,110 +1,0 @@
-/*
- * ActOnAlltest.hpp
- *
- *  Created on: 04.10.2009
- *      Author: FrederikHeber
- */
-
-#ifndef ACTONALLTEST_HPP_
-#define ACTONALLTEST_HPP_
-
-using namespace std;
-
-#include <list>
-#include "../LinearAlgebra/Vector.hpp"
-
-#define ListOfVectors list<Vector *>
-
-class VectorList
-{
-public:
-  VectorList();
-  VectorList(VectorList &ref);
-  ~VectorList();
-
-  void AddVector(Vector *v);
-  void EmptyList();
-
-  template <typename klasse, typename res, typename T> void ActOnAll( res (klasse::*f)(T), T t );
-  template <typename klasse, typename res, typename T> void ActOnAll( res (klasse::*f)(T&), T &t );
-  template <typename klasse, typename res, typename T, typename U> void ActOnAll( res (klasse::*f)(T, U), T t, U u );
-  template <typename klasse, typename res, typename T, typename U, typename V> void ActOnAll( res (klasse::*f)(T, U, V), T t, U u, V v);
-
-  bool operator == (VectorList &rhs);
-  VectorList& operator = (VectorList &ref);
-
-//private:
-  ListOfVectors Vectors;
-};
-
-
-VectorList::VectorList() { };
-VectorList::VectorList(VectorList &ref)
-{
-  ref.EmptyList();
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++) {
-    ref.Vectors.push_back(new Vector (**Runner));
-  }
-};
-
-VectorList & VectorList::operator = (VectorList &ref)
-{
-  EmptyList();
-  for (ListOfVectors::iterator Runner = ref.Vectors.begin(); Runner != ref.Vectors.end(); Runner++) {
-    Vectors.push_back(new Vector (**Runner));
-  }
-  return *this;
-};
-
-bool VectorList::operator == (VectorList &rhs)
-{
-  bool status = true;
-  ListOfVectors::iterator lRunner = Vectors.begin();
-  ListOfVectors::iterator rRunner = rhs.Vectors.begin();
-  for (;(lRunner != Vectors.end()) && (rRunner != rhs.Vectors.end()); lRunner++, rRunner++) {
-    //Log() << Verbose(0) << **lRunner << " == " << **rRunner << endl;
-    status = status && (**lRunner == **rRunner);
-  }
-  return status;
-};
-
-VectorList::~VectorList() { };
-
-template <typename klasse, typename res, typename T> void VectorList::ActOnAll( res (klasse::*f)(T), T t )
-{
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++)
-    ((*Runner)->*f)(t);
-};
-
-template <typename klasse, typename res, typename T> void VectorList::ActOnAll( res (klasse::*f)(T&), T &t )
-{
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++)
-    ((*Runner)->*f)(t);
-};
-
-template <typename klasse, typename res, typename T, typename U> void VectorList::ActOnAll( res (klasse::*f)(T, U), T t, U u )
-{
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++)
-    ((*Runner)->*f)(t, u);
-};
-
-template <typename klasse, typename res, typename T, typename U, typename V> void VectorList::ActOnAll( res (klasse::*f)(T, U, V), T t, U u, V v)
-{
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++)
-    ((*Runner)->*f)(t, u, v);
-};
-
-void VectorList::AddVector(Vector *v)
-{
-  Vectors.push_back(v);
-};
-
-void VectorList::EmptyList()
-{
-  for (ListOfVectors::iterator Runner = Vectors.begin(); Runner != Vectors.end(); Runner++) {
-    delete(*Runner);
-  }
-  Vectors.clear();
-}
-
-#endif /* ACTONALLTEST_HPP_ */
Index: c/unittests/ActOnAllUnitTest.cpp
===================================================================
--- src/unittests/ActOnAllUnitTest.cpp	(revision f7c0c4875e5eed9b9b820e4cd989c0203179be0b)
+++ 	(revision )
@@ -1,134 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * ActOnAllUnitTest.cpp
- *
- *  Created on: 04.10.2009
- *      Author: FrederikHeber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include "../test/ActOnAlltest.hpp"
-#include "ActOnAllUnitTest.hpp"
-#include "LinearAlgebra/Vector.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( ActOnAllTest );
-
-
-void ActOnAllTest::setUp()
-{
-  Vector *temp = NULL;
-  // fill list with vectors
-  temp = new Vector(1,0,0);
-  VL.AddVector(temp);
-  temp = new Vector(0,1,0);
-  VL.AddVector(temp);
-  temp = new Vector(0,0,1);
-  VL.AddVector(temp);
-  Ref = VL;
-};
-
-
-void ActOnAllTest::tearDown()
-{
-  VL.EmptyList();
-  // Ref was copy constructed, hence has to be cleaned, too!
-  Ref.EmptyList();
-};
-
-/** UnitTest for VectorList::ActOnAll() and Vector::AddVector(), Vector::SubtractVector(),
- */
-void ActOnAllTest::AddSubtractTest()
-{
-  const Vector test(1.,0.,0.);
-
-  // adding, subtracting
-  VL.ActOnAll( &Vector::AddVector, test );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-  VL.ActOnAll( &Vector::SubtractVector, test );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
-};
-
-/** UnitTest for VectorList::ActOnAll()
- */
-void ActOnAllTest::ScaleTest()
-{
-  double factor=2.;
-  double inverse=1./2.;
-
-  // scaling by value
-  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, factor );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-
-  VL.ActOnAll( (void (Vector::*)(const double)) &Vector::Scale, inverse );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
-
-  // scaling by three values
-  double *factors = new double[NDIM];
-  double *inverses = new double[NDIM];
-  for (int i=0;i<NDIM;++i) {
-    factors[i] = 2.;
-    inverses[i] = 1./factors[i];
-  }
-  VL.ActOnAll<Vector,void,const double*>(&Vector::ScaleAll, factors );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-
-  VL.ActOnAll<Vector,void,const double*>(&Vector::ScaleAll, inverses );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , true );
-  delete[](factors);
-  delete[](inverses);
-};
-
-#if 0
-
-// Unitttest deactivated for now...
-// Reasons:
-//    Vector::MakeNormalVector has been removed and is now part of Plane class
-//    VectorList::ActOnAll is in the test directory and seems to be used only for unittests
-//    MakeNormal never depended on the input Vector except in the case of linear dependence (i.e. failure)
-//
-// TODO: Rethink what exactely is being tested at this point and introduce a new unittest for the
-//       tested behaviour. Most likely this should result in a thourough unittest of the plane class
-
-/** UnitTest for VectorList::ActOnAll() and Vector::MakeNormalVector()
- */
-void ActOnAllTest::NormalizeTest()
-{
-  const Vector xaxis(1.,0.,0.);
-  const Vector yaxis(0.,1.,0.);
-
-  // normalize with respect to x and y axis
-  bool (Vector::*f)(const Vector *, const Vector *) = &Vector::MakeNormalVector;
-  VL.ActOnAll( f, &xaxis, &yaxis );
-  CPPUNIT_ASSERT_EQUAL( VL == Ref , false );
-
-  // check that x and y components are zero
-  for (ListOfVectors::iterator Runner = VL.Vectors.begin(); Runner != VL.Vectors.end(); Runner++) {
-    CPPUNIT_ASSERT_EQUAL( (*Runner)->at(0) , 0. );
-    CPPUNIT_ASSERT_EQUAL( (*Runner)->at(1) , 0. );
-  }
-};
-
-#endif
Index: c/unittests/ActOnAllUnitTest.hpp
===================================================================
--- src/unittests/ActOnAllUnitTest.hpp	(revision f7c0c4875e5eed9b9b820e4cd989c0203179be0b)
+++ 	(revision )
@@ -1,41 +1,0 @@
-/*
- * ActOnAllUnitTest.hpp
- *
- *  Created on: 04.10.2009
- *      Author: FrederikHeber
- */
-
-#ifndef ACTONALLUNITTEST_HPP_
-#define ACTONALLUNITTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-#include "../test/ActOnAlltest.hpp"
-
-/********************************************** Test classes **************************************/
-
-class ActOnAllTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( ActOnAllTest) ;
-    CPPUNIT_TEST ( AddSubtractTest );
-    CPPUNIT_TEST ( ScaleTest );
-#if 0
-    // test deactivated. See .cpp for reasons and workarounds
-    CPPUNIT_TEST ( NormalizeTest );
-#endif
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-      void setUp();
-      void tearDown();
-      void AddSubtractTest();
-      void ScaleTest();
-      void NormalizeTest();
-
-private:
-      class VectorList VL;
-      class VectorList Ref;
-};
-
-
-#endif /* ACTONALLUNITTEST_HPP_ */
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision f7c0c4875e5eed9b9b820e4cd989c0203179be0b)
+++ src/unittests/Makefile.am	(revision 456e78e35fb62976d5ccc14000867cdfdf3da8bc)
@@ -13,5 +13,4 @@
 
 TESTS = \
-  ActOnAllUnitTest \
   AnalysisBondsUnitTests \
   AnalysisCorrelationToPointUnitTest \
@@ -73,5 +72,4 @@
 TESTSOURCES = \
   ../Actions/unittests/ActionRegistryUnitTest.cpp \
-  ActOnAllUnitTest.cpp \
   ../Actions/unittests/ActionSequenceUnitTest.cpp \
   analysisbondsunittest.cpp \
@@ -114,5 +112,4 @@
 TESTHEADERS = \
   ../Actions/unittests/ActionRegistryUnitTest.hpp \
-  ActOnAllUnitTest.hpp \
   ../Actions/unittests/ActionSequenceUnitTest.hpp \
   analysisbondsunittest.hpp \
@@ -155,7 +152,4 @@
   
 
-ActOnAllUnitTest_SOURCES = UnitTestMain.cpp ../test/ActOnAllTest.hpp ActOnAllUnitTest.cpp ActOnAllUnitTest.hpp
-ActOnAllUnitTest_LDADD = ${ALLLIBS}
-
 AnalysisBondsUnitTests_SOURCES = UnitTestMain.cpp analysisbondsunittest.cpp analysisbondsunittest.hpp
 AnalysisBondsUnitTests_LDADD = ${ALLLIBS}