Index: tests/regression/Geometry/PlaneToVector/post/test.xyz
===================================================================
--- tests/regression/Geometry/PlaneToVector/post/test.xyz	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
+++ tests/regression/Geometry/PlaneToVector/post/test.xyz	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
@@ -0,0 +1,6 @@
+4
+	created for regression test PlaneToVector on 2017-03-31 09:54
+H	1	0	0
+H	1	0	1
+H	1	1	0
+C	3	2	2
Index: tests/regression/Geometry/PlaneToVector/pre/test.xyz
===================================================================
--- tests/regression/Geometry/PlaneToVector/pre/test.xyz	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
+++ tests/regression/Geometry/PlaneToVector/pre/test.xyz	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
@@ -0,0 +1,6 @@
+4
+	created for regression test PlaneToVector on 2017-03-31 09:53
+H	1	0	0
+H	1	0	1
+H	1	1	0
+C	2	2	2
Index: tests/regression/Geometry/PlaneToVector/testsuite-geometry-plane-to-vector.at
===================================================================
--- tests/regression/Geometry/PlaneToVector/testsuite-geometry-plane-to-vector.at	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
+++ tests/regression/Geometry/PlaneToVector/testsuite-geometry-plane-to-vector.at	(revision 467b2b6c9cffa66334d7480f3653a3ce169ac83f)
@@ -0,0 +1,53 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### plane to vector
+
+AT_SETUP([Geometry - plane to vector])
+AT_KEYWORDS([geometry plane-to-vector])
+AT_XFAIL_IF([/bin/true])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/PlaneToVector/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -v 5 \
+	--select-atom-by-id 0 1 2 --plane-to-vector "testvector" --unselect-all-atoms \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*reated.*' $file ${abs_top_srcdir}/tests/regression/Geometry/PlaneToVector/post/$file], 0, [ignore], [ignore])
+AT_CLEANUP
+
+AT_SETUP([Geometry - plane to vector Undo])
+AT_KEYWORDS([geometry plane-to-vector undo])
+AT_XFAIL_IF([/bin/true])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/PlaneToVector/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file \
+	--select-atom-by-id 0 1 2 --plane-to-vector "testvector" --undo --unselect-all-atoms \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 5, [ignore], [ignore])
+AT_CLEANUP
+
+AT_SETUP([Geometry - plane to vector Redo])
+AT_KEYWORDS([geometry plane-to-vector undo redo])
+AT_XFAIL_IF([/bin/true])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/PlaneToVector/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file \
+	--select-atom-by-id 0 1 2 --plane-to-vector "testvector" --undo --redo --unselect-all-atoms \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*reated.*' $file ${abs_top_srcdir}/tests/regression/Geometry/PlaneToVector/post/$file], 0, [ignore], [ignore])
+AT_CLEANUP