Index: src/Potentials/Specifics/unittests/Makefile.am
===================================================================
--- src/Potentials/Specifics/unittests/Makefile.am	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ src/Potentials/Specifics/unittests/Makefile.am	(revision 484e2ac103bbd121925bede487af209b526f8d12)
@@ -5,24 +5,24 @@
 	../Potentials/Specifics/unittests/ConstantPotentialUnitTest.cpp \
 	../Potentials/Specifics/unittests/ManyBodyPotential_TersoffUnitTest.cpp \
-	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.cpp \
 	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp \
 	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.cpp \
-	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp
+	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp \
+	../Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.cpp
 
 POTENTIALSSPECIFICSTESTSHEADERS = \
 	../Potentials/Specifics/unittests/ConstantPotentialUnitTest.hpp \
 	../Potentials/Specifics/unittests/ManyBodyPotential_TersoffUnitTest.hpp \
-	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.hpp \
 	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.hpp \
 	../Potentials/Specifics/unittests/PairPotential_LennardJonesUnitTest.hpp \
-	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.hpp
+	../Potentials/Specifics/unittests/PairPotential_MorseUnitTest.hpp \
+	../Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.hpp
 
 POTENTIALSSPECIFICSTESTS = \
 	ConstantPotentialUnitTest \
 	ManyBodyPotential_TersoffUnitTest \
-	PairPotential_AngleUnitTest \
 	PairPotential_HarmonicUnitTest \
 	PairPotential_LennardJonesUnitTest \
-	PairPotential_MorseUnitTest
+	PairPotential_MorseUnitTest \
+	ThreeBodyPotential_AngleUnitTest
 
 TESTS += $(POTENTIALSSPECIFICSTESTS)
@@ -50,9 +50,4 @@
 ManyBodyPotential_TersoffUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
 
-PairPotential_AngleUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
-	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.cpp \
-	../Potentials/Specifics/unittests/PairPotential_AngleUnitTest.hpp
-PairPotential_AngleUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
-
 PairPotential_HarmonicUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
 	../Potentials/Specifics/unittests/PairPotential_HarmonicUnitTest.cpp \
@@ -70,4 +65,9 @@
 PairPotential_MorseUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
 
+ThreeBodyPotential_AngleUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.cpp \
+	../Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.hpp
+ThreeBodyPotential_AngleUnitTest_LDADD = ${POTENTIALSSPECIFICSLIBS}
+
 
 #AUTOMAKE_OPTIONS = parallel-tests
Index: src/Potentials/Specifics/unittests/PairPotential_AngleUnitTest.cpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_AngleUnitTest.cpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ 	(revision )
@@ -1,174 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2012 University of Bonn. All rights reserved.
- * Copyright (C)  2013 Frederik Heber. All rights reserved.
- * 
- *
- *   This file is part of MoleCuilder.
- *
- *    MoleCuilder is free software: you can redistribute it and/or modify
- *    it under the terms of the GNU General Public License as published by
- *    the Free Software Foundation, either version 2 of the License, or
- *    (at your option) any later version.
- *
- *    MoleCuilder is distributed in the hope that it will be useful,
- *    but WITHOUT ANY WARRANTY; without even the implied warranty of
- *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *    GNU General Public License for more details.
- *
- *    You should have received a copy of the GNU General Public License
- *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-/*
- * PairPotential_AngleUnitTest.cpp
- *
- *  Created on: Oct 16, 2012
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include "PairPotential_AngleUnitTest.hpp"
-
-#include <boost/assign.hpp>
-
-#include "CodePatterns/Assert.hpp"
-
-#include "FunctionApproximation/FunctionArgument.hpp"
-#include "Potentials/Specifics/PairPotential_Angle.hpp"
-#include "Potentials/helpers.hpp"
-
-using namespace boost::assign;
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( PairPotential_AngleTest );
-
-const double spring_constant = .5;
-
-void PairPotential_AngleTest::setUp()
-{
-  // failing asserts should be thrown
-  ASSERT_DO(Assert::Throw);
-
-  // create three distances to have the desired angle
-  typedef std::vector<double> angles_t;
-  angles_t angles;
-  angles += -0.5, -.4, -.3, -.2, -.1, 0., .1, .2, .3, .4, .5;
-  FunctionModel::arguments_t tempvector(3);
-  tempvector[0] = argument_t( std::make_pair(0,1), std::make_pair(0,1), 1.);
-  tempvector[1] = argument_t( std::make_pair(1,2), std::make_pair(1,1), 0.);
-  tempvector[2] = argument_t( std::make_pair(0,2), std::make_pair(0,1), 1.);
-  for (angles_t::const_iterator iter = angles.begin(); iter != angles.end(); ++iter) {
-    tempvector[1].distance = sqrt(-(2.*(*iter)-2.));//1.+1.-x/(2.*1.*1.)
-    input += tempvector;
-  }
-  output +=
-      spring_constant*0.25,
-      spring_constant*0.16,
-      spring_constant*0.09,
-      spring_constant*0.04,
-      spring_constant*0.01,
-      spring_constant*0.,
-      spring_constant*0.01,
-      spring_constant*0.04,
-      spring_constant*0.09,
-      spring_constant*0.16,
-      spring_constant*0.25;
-
-  CPPUNIT_ASSERT_EQUAL( input.size(), output.size() );
-}
-
-
-void PairPotential_AngleTest::tearDown()
-{
-}
-
-/** UnitTest for operator()
- */
-void PairPotential_AngleTest::operatorTest()
-{
-  PairPotential_Angle::ParticleTypes_t types =
-      boost::assign::list_of<PairPotential_Angle::ParticleType_t>
-        (0)(1)(1)
-      ;
-  PairPotential_Angle angle(types, spring_constant,0.);
-  for (size_t index = 0; index < input.size(); ++index) {
-    const PairPotential_Angle::results_t result =
-        angle( input[index] );
-    CPPUNIT_ASSERT(
-        Helpers::isEqual(
-            output[index],
-            result[0]
-        )
-    );
-  }
-}
-
-/** UnitTest for derivative()
- */
-void PairPotential_AngleTest::derivativeTest()
-{
-  PairPotential_Angle::ParticleTypes_t types =
-      boost::assign::list_of<PairPotential_Angle::ParticleType_t>
-        (0)(1)(1)
-      ;
-  PairPotential_Angle angle(types, spring_constant,0.);
-  CPPUNIT_ASSERT(
-      Helpers::isEqual(
-          0.,
-          angle.derivative(
-              input[5]
-          )[0],
-          10.
-      )
-  );
-}
-
-
-/** UnitTest for parameter_derivative()
- */
-void PairPotential_AngleTest::parameter_derivativeTest()
-{
-  PairPotential_Angle::ParticleTypes_t types =
-      boost::assign::list_of<PairPotential_Angle::ParticleType_t>
-        (0)(1)(1)
-      ;
-  PairPotential_Angle angle(types, spring_constant,0.);
-  CPPUNIT_ASSERT(
-      Helpers::isEqual(
-          0.,
-          angle.parameter_derivative(
-              input[5],
-              0
-          )[0],
-          10.
-      )
-  );
-  CPPUNIT_ASSERT(
-      Helpers::isEqual(
-          0.,
-          angle.parameter_derivative(
-              input[5],
-              1
-          )[0],
-          10.
-      )
-  );
-}
Index: src/Potentials/Specifics/unittests/PairPotential_AngleUnitTest.hpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_AngleUnitTest.hpp	(revision 1413f4555b944ca972d0d485541e58d325f62feb)
+++ 	(revision )
@@ -1,46 +1,0 @@
-/*
- * PairPotential_AngleUnitTest.hpp
- *
- *  Created on: Oct 16, 2012
- *      Author: heber
- */
-
-#ifndef PAIRPOTENTIAL_ANGLEUNITTEST_HPP_
-#define PAIRPOTENTIAL_ANGLEUNITTEST_HPP_
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-
-#include <cppunit/extensions/HelperMacros.h>
-
-#include "FunctionApproximation/FunctionModel.hpp"
-
-class PairPotential_Angle;
-
-/********************************************** Test classes **************************************/
-
-class PairPotential_AngleTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( PairPotential_AngleTest) ;
-    CPPUNIT_TEST ( operatorTest );
-    CPPUNIT_TEST ( derivativeTest );
-    CPPUNIT_TEST ( parameter_derivativeTest );
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-      void setUp();
-      void tearDown();
-      void operatorTest();
-      void derivativeTest();
-      void parameter_derivativeTest();
-
-private:
-      typedef std::vector<double> data_t;
-      std::vector<FunctionModel::arguments_t> input;
-      data_t output;
-};
-
-#endif /* PAIRPOTENTIAL_ANGLEUNITTEST_HPP_ */
Index: src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.cpp
===================================================================
--- src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.cpp	(revision 484e2ac103bbd121925bede487af209b526f8d12)
+++ src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.cpp	(revision 484e2ac103bbd121925bede487af209b526f8d12)
@@ -0,0 +1,174 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Copyright (C)  2013 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * ThreeBodyPotential_AngleUnitTest.cpp
+ *
+ *  Created on: Oct 16, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "ThreeBodyPotential_AngleUnitTest.hpp"
+
+#include <boost/assign.hpp>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "FunctionApproximation/FunctionArgument.hpp"
+#include "Potentials/Specifics/ThreeBodyPotential_Angle.hpp"
+#include "Potentials/helpers.hpp"
+
+using namespace boost::assign;
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( ThreeBodyPotential_AngleTest );
+
+const double spring_constant = .5;
+
+void ThreeBodyPotential_AngleTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // create three distances to have the desired angle
+  typedef std::vector<double> angles_t;
+  angles_t angles;
+  angles += -0.5, -.4, -.3, -.2, -.1, 0., .1, .2, .3, .4, .5;
+  FunctionModel::arguments_t tempvector(3);
+  tempvector[0] = argument_t( std::make_pair(0,1), std::make_pair(0,1), 1.);
+  tempvector[1] = argument_t( std::make_pair(1,2), std::make_pair(1,1), 0.);
+  tempvector[2] = argument_t( std::make_pair(0,2), std::make_pair(0,1), 1.);
+  for (angles_t::const_iterator iter = angles.begin(); iter != angles.end(); ++iter) {
+    tempvector[1].distance = sqrt(-(2.*(*iter)-2.));//1.+1.-x/(2.*1.*1.)
+    input += tempvector;
+  }
+  output +=
+      spring_constant*0.25,
+      spring_constant*0.16,
+      spring_constant*0.09,
+      spring_constant*0.04,
+      spring_constant*0.01,
+      spring_constant*0.,
+      spring_constant*0.01,
+      spring_constant*0.04,
+      spring_constant*0.09,
+      spring_constant*0.16,
+      spring_constant*0.25;
+
+  CPPUNIT_ASSERT_EQUAL( input.size(), output.size() );
+}
+
+
+void ThreeBodyPotential_AngleTest::tearDown()
+{
+}
+
+/** UnitTest for operator()
+ */
+void ThreeBodyPotential_AngleTest::operatorTest()
+{
+  ThreeBodyPotential_Angle::ParticleTypes_t types =
+      boost::assign::list_of<ThreeBodyPotential_Angle::ParticleType_t>
+        (0)(1)(1)
+      ;
+  ThreeBodyPotential_Angle angle(types, spring_constant,0.);
+  for (size_t index = 0; index < input.size(); ++index) {
+    const ThreeBodyPotential_Angle::results_t result =
+        angle( input[index] );
+    CPPUNIT_ASSERT(
+        Helpers::isEqual(
+            output[index],
+            result[0]
+        )
+    );
+  }
+}
+
+/** UnitTest for derivative()
+ */
+void ThreeBodyPotential_AngleTest::derivativeTest()
+{
+  ThreeBodyPotential_Angle::ParticleTypes_t types =
+      boost::assign::list_of<ThreeBodyPotential_Angle::ParticleType_t>
+        (0)(1)(1)
+      ;
+  ThreeBodyPotential_Angle angle(types, spring_constant,0.);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          angle.derivative(
+              input[5]
+          )[0],
+          10.
+      )
+  );
+}
+
+
+/** UnitTest for parameter_derivative()
+ */
+void ThreeBodyPotential_AngleTest::parameter_derivativeTest()
+{
+  ThreeBodyPotential_Angle::ParticleTypes_t types =
+      boost::assign::list_of<ThreeBodyPotential_Angle::ParticleType_t>
+        (0)(1)(1)
+      ;
+  ThreeBodyPotential_Angle angle(types, spring_constant,0.);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          angle.parameter_derivative(
+              input[5],
+              0
+          )[0],
+          10.
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          angle.parameter_derivative(
+              input[5],
+              1
+          )[0],
+          10.
+      )
+  );
+}
Index: src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.hpp
===================================================================
--- src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.hpp	(revision 484e2ac103bbd121925bede487af209b526f8d12)
+++ src/Potentials/Specifics/unittests/ThreeBodyPotential_AngleUnitTest.hpp	(revision 484e2ac103bbd121925bede487af209b526f8d12)
@@ -0,0 +1,46 @@
+/*
+ * ThreeBodyPotential_AngleUnitTest.hpp
+ *
+ *  Created on: Oct 16, 2012
+ *      Author: heber
+ */
+
+#ifndef THREEBODYPOTENTIAL_ANGLEUNITTEST_HPP_
+#define THREEBODYPOTENTIAL_ANGLEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "FunctionApproximation/FunctionModel.hpp"
+
+class ThreeBodyPotential_Angle;
+
+/********************************************** Test classes **************************************/
+
+class ThreeBodyPotential_AngleTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( ThreeBodyPotential_AngleTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST ( derivativeTest );
+    CPPUNIT_TEST ( parameter_derivativeTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+      void derivativeTest();
+      void parameter_derivativeTest();
+
+private:
+      typedef std::vector<double> data_t;
+      std::vector<FunctionModel::arguments_t> input;
+      data_t output;
+};
+
+#endif /* THREEBODYPOTENTIAL_ANGLEUNITTEST_HPP_ */