Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo-empty.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo-empty.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
+++ tests/regression/Parser/Tremolo/testsuite-parser-tremolo-empty.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
@@ -0,0 +1,11 @@
+### parsing tremolo
+
+AT_SETUP([Parser - loading empty tremolo file])
+AT_KEYWORDS([parser,tremolo,emptyfile])
+
+file=empty.data
+AT_CHECK([/bin/cp ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/empty.data $file], 0, [ignore], [ignore])
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file -o tremolo], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
+++ tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
@@ -0,0 +1,33 @@
+### parsing tremolo
+
+
+AT_SETUP([Parser - loading tremolo file])
+AT_KEYWORDS([parser,tremolo])
+
+file=argon.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/argon.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading tremolo file with Undo])
+AT_XFAIL_IF([/bin/true])
+AT_KEYWORDS([parser,tremolo])
+
+file=argon.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/argon.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading tremolo file with Redo])
+AT_XFAIL_IF([/bin/true])
+AT_KEYWORDS([parser,tremolo])
+
+file=argon.data
+AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/argon.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo-save.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo-save.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
+++ tests/regression/Parser/Tremolo/testsuite-parser-tremolo-save.at	(revision 520f93930dc8a9f478562e28fb307e3e18d9b0bc)
@@ -0,0 +1,21 @@
+### parsing tremolo
+
+
+AT_SETUP([Parser - saving tremolo file])
+AT_KEYWORDS([parser,tremolo])
+
+file=test.data
+AT_CHECK([/bin/cp ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/test.data $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o tremolo --output store.data], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '#.*' store.data ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/test.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - saving tremolo from loaded xyz file])
+AT_KEYWORDS([parser,tremolo,xyz])
+
+AT_CHECK([../../molecuilder -i test.xyz  -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([file=test.data; diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/test.data], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ 	(revision )
@@ -1,63 +1,0 @@
-### parsing tremolo
-
-AT_SETUP([Parser - loading empty tremolo file])
-AT_KEYWORDS([parser,tremolo,emptyfile])
-
-file=empty.data
-AT_CHECK([/bin/cp ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/empty.data $file], 0, [ignore], [ignore])
-AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file -o tremolo], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - loading tremolo file])
-AT_KEYWORDS([parser,tremolo])
-
-file=argon.data
-AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data], 0, [ignore], [ignore])
-AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/argon.data], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - loading tremolo file with Undo])
-AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([parser,tremolo])
-
-file=argon.data
-AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data --undo], 0, [ignore], [ignore])
-AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/empty.data], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - loading tremolo file with Redo])
-AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([parser,tremolo])
-
-file=argon.data
-AT_CHECK([../../molecuilder -i $file -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/argon.data --undo --redo], 0, [ignore], [ignore])
-AT_CHECK([diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/argon.data], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - saving tremolo file])
-AT_KEYWORDS([parser,tremolo])
-
-file=test.data
-AT_CHECK([/bin/cp ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/test.data $file], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $file -o tremolo --output store.data], 0, [ignore], [ignore])
-AT_CHECK([diff -w -I '#.*' store.data ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/test.data], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - storing tremolo from loaded xyz file])
-AT_KEYWORDS([parser,tremolo,xyz])
-
-AT_CHECK([../../molecuilder -i test.xyz  -o tremolo -l ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/pre/test.xyz], 0, [ignore], [ignore])
-AT_CHECK([file=test.data; diff -w -I '#.*' $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Parser/Tremolo/post/test.data], 0, [ignore], [ignore])
-
-AT_CLEANUP